# Amahi Notificator
# Copyright (C) 2009 Filipe Felisberto
# Developed for Amahi Home Server
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License v3
# (29 June 2007), as published in the COPYING file.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# file COPYING for more details.

require 'rubygems'
require "yaml"
require "twitter"
require "xml"
require '/var/hda/platform/html/lib/amahi_api.rb'

CKEY="mnp"
CSECRET="abc"
CONFIG_FILE = "config.yml"

def log(message)
        Syslog.open("servertweet", Syslog::LOG_PID | Syslog::LOG_CONS) do |s|
                s.warning message
        end
end

class AmahiServerInformation
        def initialize ()

        end
        def verify_alive(name)
                if self.verify_app(name)
                        command = "ps aux | grep "+name+" | wc -l "
                        s = `#{command}`
                        return Integer(s) > 2
                else
                        return false
                end
        end
        def uptime
                upt=`uptime`
                upt =  upt[(/\up(?:\s+[^,]+)/)]
                return upt[/[^up ](?:.+)/]
        end
        def verify_app(name)
                return (name=~/^[a-zA-Z0-9_-]*$/)!= nil
        end
        def free_space(drive)
                command = "df -h "+drive
                s = `#{command}`
                if s.empty?
                        return "ERROR"
	
                end
                return 100-Integer(s[/\s(?:\d+%)/].chop)
        end
        def total_data_today_ds(xml)
                t = Time.now
                day = t.day
                parser = XML::Parser.file(xml)
                doc = parser.parse
                days = doc.find("/graphs/days/e[@p=#{day}]") 
                totali=0
                totalo=0
                days.each do |node|
                	totali = Integer(node["i"])
                        totalo = Integer(node["o"])        
                end
                total = [totali,totalo];
                return total
        end
        def convert_bytes(bytes)
                megas=Float(bytes)/1024/1024

                if(megas > 1024)
                        result = megas/1024
                        result = String(Float( (result*100).round())/100)+"GB"
                else
                        result = megas
                        result = String(Float( (result*100).round())/100)+"MB"
                end

                return result
        end 
end

class AmahiNotificatorSummary
        def initialize (config,network)
                @network = network
                @config =  config

        end

        def create_summary()
                info = AmahiServerInformation.new
                summary="";
                if @config["uptime"]
                        summary = summary+"Uptime: "+ info.uptime+" * "
                end
                unless @config["freespace"].empty?
                        @config["freespace"].each { |item,nick|
                                summary+="#{nick}: #{info.free_space(item)}% * "

                        }
                end
                unless @config["apps"].empty?
                        @config["apps"].each { |item|

                                if(info.verify_alive(item))
                                        summary+=item+" Up * "
                                else summary+=item+" Down * "
                                end

                        }
                end
                if @config["darkstat"]
                        if(info.verify_alive("darkstat"))
                                updown = info.total_data_today_ds(@config["dk_url"])
                                summary = summary + "Net IN/OUT: "+info.convert_bytes(updown[0])+"/"+info.convert_bytes(updown[1])+"\n"
                        end
                end
                @network.send_data(summary)
        end
end
class AmahiNotificatorNetwork
        def initialize (config,api_key)
                @twit=0
                @api_key=api_key
                @email = "";
                @client = nil;

                if(config["email"] != "")
                        @email= config["email"]
                end
                if(config["twitter_server"])
                        @twit=1
                elsif(config["twitInternal"] and !config["twitUser"].empty? and !config["twitPwd"].empty? )
                        @twit = 2
                        twitUser= config["twitUser"]
                        twitPwd = Base64.decode64(config["twitPwd"])
                        begin

                                httpauth = Twitter::HTTPAuth.new(twitUser,twitPwd )
                                @client = Twitter::Base.new(httpauth)

                        rescue Exception => e
                                log(e) 
                        end

                end

                log("Twit = #{@twit}")

        end
        def send_data(data)
                log("Twit send_data = #{@twit}")
                if @twit > 0
                        send_twit(data)
                end
                if @email != nil
                        send_email(data)
                end
        end
        def send_twit(text)
                log("Twit twit = #{@twit}")
                if @twit == 1
                        #contact server
                else
                        log("Sending twit internal")
                        begin
                                @client.update(text)
                        rescue Exception => e
                                log(e)
                        end


                end
        end
        def send_email(text)
                begin
                        log("Sending Mail")
                        AmahiApi::api_key = @api_key
                        m = AmahiApi::TimelineEvent.new(:kind => "network", :message => text)
                        m.save
                rescue Exception => e
                        log(e)
                end

                #puts text
        end
end
