class HdaAppServerTweetController < ApplicationController

  def initialize
    @app_title = "ServerTweet"
    @app_logo =""
    @app_url ="http://servertweet/"
  end

  def index
	@uptime = HdaAppServerTweet.find_by_name "Uptime"
	unless @uptime
	  @uptime=HdaAppServerTweet.create(:name => "Uptime")
	end 
	@network = HdaAppServerTweet.find_by_name "Network"
	unless @network
	  @network = HdaAppServerTweet.create(:name => "Network") 
  end
	@applications = HdaAppServerTweet.find_by_name "Applications"
	unless @applications
	  @applications = HdaAppServerTweet.create(:name => "Applications") 
	end	
	@darkstat = HdaAppServerTweet.find_by_name "Darkstat"
	unless @darkstat
	  @darkstat = HdaAppServerTweet.create(:name => "Darkstat", :settings => "http://localhost:667/graphs.xml")
  end
  @time = HdaAppServerTweet.find_by_name "Time"
  unless @time
    @time = HdaAppServerTweet.create(:name => "Time", :settings => "0")
  end
  @timeType = HdaAppServerTweet.find_by_name "TimeType"
  unless @timeType
    @timeType = HdaAppServerTweet.create(:name => "TimeType", :settings => "2")  
  end
  @twitInternal = HdaAppServerTweet.find_by_name "TwitInternal"
  unless @twitInternal
    @twitInternal = HdaAppServerTweet.create(:name => "TwitInternal", :enabled => false)  
  end
  @twitIntPwd = HdaAppServerTweet.find_by_name "TwitInternalPass"
  unless @twitIntPwd
    @twitIntPwd = HdaAppServerTweet.create(:name => "TwitInternalPass")  
  end
  partitions_init
  end
  
  def config_acount_twit
    id = params[:id]
  	twit = HdaAppServerTweet.find id
  	user = params[:user]
  	pwd = params[:password]
  	if (user=~/^\w*$/)!= nil and !pwd.empty?
	    twit.settings = user
	    twitPwd = HdaAppServerTweet.find_by_name "TwitInternalPass"
	    twitPwd.settings = Base64.encode64(pwd)
	    twit.save
	    twitPwd.save
	  end
  	update
  end

  def toggle_setting
	id = params[:id]
	# toggle the setting
	setting = HdaAppServerTweet.find id
	setting.enabled = ! setting.enabled
	setting.save
	# read all values, since we're rendering all the settings
	update
  end
  
  def toggle_setting_twitInt
	id = params[:id]
	# toggle the setting
	setting = HdaAppServerTweet.find id
	setting.enabled = ! setting.enabled
	unless setting.enabled
    setting.settings = ""
    twitPwd = HdaAppServerTweet.find_by_name "TwitInternalPass"
    twitPwd.settings = ""
    twitPwd.save
  else
    flash.now[:warning] = "1-DON'T use your main acount!&nbsp;2-Setup an acount with a password you don't use anywhere else!&nbsp;3-Follow this acount using your main one&nbsp;4-Put this one in private and allow only trusted acounts&nbsp;" 
  end
	setting.save
	
	update
  end
  

  
  
  def update_apps
	id = params[:id]
	apps = HdaAppServerTweet.find id
	new_apps = params[:value]
	# FIXME - validate this!
	apps.settings = new_apps.split(/[, ]+/).join(', ')
	apps.save
	res = apps.settings
	res = "(add)" if apps.settings.empty?
	render :text => res
  end
  
  def time_edit
	id = params[:id]
	time = HdaAppServerTweet.find id
	new_time = params[:number]
  if(new_time =~/\D/) != nil
	  new_time="0"
	end
	time.settings = new_time
	time.save
	update
  end
  
  def time_type_edit
	id = params[:id]
	time = HdaAppServerTweet.find id
	new_time = params[:timeType][:settings]
	time.settings = new_time
	time.save
	update
  end
  
  def part_nick_edit
	id = params[:id]
	part = HdaAppServerTweet.find id
	new_set = params[:nick]
  unless new_set.empty? 
    part.settings = params[:nick]
    part.save
  end
  update
  end

protected
  
  def update
  @uptime = HdaAppServerTweet.find_by_name "Uptime"
  @network = HdaAppServerTweet.find_by_name "Network"
  @applications = HdaAppServerTweet.find_by_name "Applications"
  @darkstat = HdaAppServerTweet.find_by_name "Darkstat"
  @time = HdaAppServerTweet.find_by_name "Time"
  @timeType = HdaAppServerTweet.find_by_name "TimeType"
  @twitInternal = HdaAppServerTweet.find_by_name "TwitInternal"
  partitions_init
  render :partial => 'all'
  end
  
  def partitions_init
    disk = `df -h`
    @partitions = []
    i=1;
    disk.each do |each|
      if each[/^\W\w+\S+/] != nil
        part = HdaAppServerTweet.find_by_name each[/^\W\w+\S+/]
      	unless part
      	  part = HdaAppServerTweet.create(:name => each[/^\W\w+\S+/], :enabled => false,:settings => "Disk #{i}" )
      	  i+=1 
        end
        @partitions << part
      end
    end
  end
end
